=== debian/watch ===
version=3
opts="uversionmangle=s/^([1-9][0-9]*\.[0-9])([1-9])/$1.$2/" \
https://libwebsockets.org/git/cgi-bin/cgit/libwebsockets/refs/ .*libwebsockets-([1-9][0-9.]*)[a-z0-9.-]*\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))
