=== debian/changelog ===
libwebsockets (1.7.3-1) unstable; urgency=medium

  * New upstream release.

 -- Peter Pentchev <roam@ringlet.net>  Mon, 29 Feb 2016 13:24:01 +0200
